﻿import std.string;
import std.c.windows.windows;
import std.gc;

private int iterator = 0;

extern (C)
{
	void _minit();
	void _moduleCtor();
	void _moduleDtor();
	void _moduleUnitTests();
}

extern (Windows) BOOL DllMain(HINSTANCE hInstance, ULONG ulReason, LPVOID pvReserved)
{
	switch (ulReason)
	{
		case DLL_PROCESS_ATTACH: assert(0 == iterator++); break;
		
		case DLL_PROCESS_DETACH:
			assert(6 == iterator++);
			std.c.stdio._fcloseallp = null; // 標準入出力を閉じないように
			break;
			
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
			assert(false);
	}
	return true;
}

export void MyDLL_Initialize(void* gc)
{
	assert(1 == iterator++);
	std.gc.setGCHandle(gc);
	_minit();
	_moduleCtor();
	_moduleUnitTests();
}

static this() { assert(2 == iterator++); }
unittest { assert(3 == iterator++); }

export void MyDLL_Terminate()
{
	assert(4 == iterator++);
	_moduleDtor();
	std.gc.endGCHandle();
}

static ~this() { assert(5 == iterator++); }


class MyClass
{
	char[] concat(char[] a, char[] b) { return a ~ " " ~ b; }
	void free(char[] s) { delete s; }
}

export MyClass getMyClass() { return new MyClass(); }
