﻿// window描画、init.rjで初期化を行う
import std.cstream;

int main()
{
	try
	{
		auto SdlBaseTest test = new SdlBaseTest();
		dout.writefln("width = %d, height = %d, getTicks = %d",
			test.width, test.height, test.getTicks());
		while (test.doEvents())
		{
			SdlBaseTest.sleep(15);
			test.swapBuffers();
		}
		dout.writefln("getTicks = %d", test.getTicks());
	}
	catch (Exception e)
	{
		derr.writeLine(e.toString());
	}
	return 0;
}

interface _SdlBaseTest
{
	bit doEvents();
	void swapBuffers();
	static uint getTicks();
	static void sleep(uint ms);
	uint width();
	uint height();
}

auto class SdlBaseTest : _SdlBaseTest
{
	private import hdk.sdlbase;
	mixin SdlBase;
}
