﻿// input test, input.rjでカスタマイズ
import std.cstream;

int main()
{
	static assert(97 == 'a');
	try
	{
		auto SdlInputTest test = new SdlInputTest();
		test.swapBuffers();
		
		void testHandler(uint input)
		{
			dout.writef("h(%d)", input);
			dout.flush();
		}
		test.inputHandler = &testHandler;
		
		bit murFlag() { return test.mouseX > 0.9 && test.mouseY > 0.9 ? true : false; }
		test.wait("move cursor to the upper right...", &murFlag);
		
		bit mllFlag() { return test.mouseX < -0.9 && test.mouseY < -0.9 ? true : false; }
		test.wait("move cursor to the lower left...", &mllFlag);
		
		bit mouseLeftOn() { return test.hasInput(0); }
		test.wait("push mouse left button...", &mouseLeftOn);
		
		bit mouseLeftOff() { return test.hasInput(1); }
		test.wait("pop mouse left button...", &mouseLeftOff);
		
		bit aOn() { return test.hasInput(4); }
		test.wait("push 'a' button...", &aOn);
		
		bit aOff() { return test.hasInput(5); }
		test.wait("pop 'a' button...", &aOff);
		
		bit upOn() { return test.hasInput(6); }
		test.wait("push joystick up...", &upOn);
		
		bit upOff() { return test.hasInput(7); }
		test.wait("pop joystick up...", &upOff);
		
		bit btn0On() { return test.hasInput(8); }
		test.wait("push joystick button0...", &btn0On);
		
		bit btn0Off() { return test.hasInput(9); }
		test.wait("pop joystick button0...", &btn0Off);
	}
	catch (Exception e)
	{
		derr.writeLine("Exception:" ~ e.toString());
	}
	return 0;
}

interface _SdlBaseTest
{
	bit doEvents();
	void swapBuffers();
	uint width();
	uint height();
}

interface _SdlInputTest
{
	int pollEvent(void* sdlEvent); // SDL_Event* event、入力を横取りする
	float mouseX();
	float mouseY();
	int opApply(int delegate(inout uint) dg);
	void inputHandler(void delegate(uint input) dg);
}

auto class SdlBaseTest : _SdlBaseTest
{
	private import hdk.sdlbase;
	mixin SdlBase;
}

auto class SdlInputTest : SdlBaseTest, _SdlInputTest
{
	private import hdk.sdlinput;
	mixin SdlInput;
	
	void doEvents2()
	{
		SDL_Event event;
		while (pollEvent(&event))
		{
			if (event.type == SDL_QUIT) error(__LINE__, "test");
		}
		SDL_Delay(1);
	}
	
	void wait(char[] msg, bit delegate() flag)
	{
		dout.writeString(msg);
		dout.flush();
		while (!flag()) doEvents2();
		dout.writeLine("ok");
	}
	
	bit hasInput(uint a)
	{
		foreach (uint input; this)
		{
			if (input == a) return true;
		}
		return false;
	}
}
