﻿import std.cstream;
import hdk.window;

alias Vector.create rgba;
alias Matrix.translation translation;
alias Matrix.scaling scaling;

int main()
{
	try
	{
		const dchar[] TEXTURE0 = `..\resource\test0.png`;
		
		auto Window wnd = new Window();
		DrawNumbers dn = new DrawNumbers();
		wnd.postTerminableCommand(dn);
		for (float a = 0.0; a < 0.5; a += 0.004)
		{
			foreach (uint n; wnd) dout.writefln("%d ", n);
			
			wnd.modelView = translation(-a, a, 0);
			wnd.drawRectangle(rgba(1, 0, 0, 1));
			
			wnd.modelView = Matrix.identity;
			wnd.drawTexture(TEXTURE0, rgba(1, 1, 1, 0.5));
			
			wnd.modelView = scaling(1.0, 32.0 / 512.0, 1.0) * translation(a, -a, 0);
			wnd.drawText("あA", rgba(0, 0, 1, 0.75));
			
			dn--;
			wnd.update();
			sleep(15);
		}
		
		dout.writefln("mouse: %f %f", wnd.mouseX, wnd.mouseY);
		dout.writeLine("main thred waiting..."); dout.flush();
		wnd.wait();
		
		dout.writeLine("ok");
	}
	catch (Exception e)
	{
		derr.writeLine("main thread Exception: " ~ e.toString());
	}
	return 0;
}

class DrawNumbers : TerminableCommand
{
	private int life = 100;
	void opPostDec() { life--; }
	bit alive() { return life > 0 ? true : false; }
	
	void opCall(WindowResource wr)
	{
		wr.depthTestWriting(true, false);
		wr.modelView = translation(0.5, -0.5, 0) * scaling(10.0, 1, 1);
		wr.drawText(std.utf.toUTF32(std.string.toString(life)), rgba(1, 0, 0, 1));
	}
}
