﻿module nanami.effect;
private import hdk.window;

/// 一つのテクスチャを分割して、それぞれを0.1秒ずつ表示する
class Effect : TerminableCommand
{
	Matrix modelView; ///
	Matrix projection; ///
	private dchar[] texture;
	private final uint divisionLength;
	private uint iterator = 0, t = 0;
	
	///
	this(dchar[] fileName, uint divisionLength)
	{
		texture = fileName;
		projection = modelView = Matrix.identity;
		this.divisionLength = divisionLength;
	}
	
	bit alive() { return iterator < divisionLength ? true : false; }
	
	void opCall(WindowResource wr)
	{
		const dchar[] EFFECT_SHADER = "effect";
		const dchar[] EFFECT_VERTEX_BUFFER = `effect.zip\vertex_buffer`;
		
		wr.depthTestWriting(false, false);
		wr.cullingEnableFront(false, true);
		wr.modelView = modelView;
		wr.projection = projection;
		wr.setShaderVector(EFFECT_SHADER, "color", vector(1, 1, 1, 1));
		wr.setShaderFloat(EFFECT_SHADER, "x", 1.0 / divisionLength * iterator);
		wr.setShaderFloat(EFFECT_SHADER, "width", 1.0 / divisionLength);
		wr.setShaderInt(EFFECT_SHADER, "texture0", 0);
		wr.drawPcnt(EFFECT_SHADER, EFFECT_VERTEX_BUFFER, texture);
		
		t++;
		if (t == 6)
		{
			iterator++;
			t = 0;
		}
	}
}
