﻿import hdk.window;
import std.cstream;
import nanami.model;
import nanami.skeleton;
import std.math;

int main()
{
	try
	{
		auto Window wnd = new Window();
		Model model = new Model(`..\resource\test.773`);
		wnd.postTerminableCommand(model);
		assert(model.hasSkeleton);
		dout.writefln("boneLength=%d", model.boneLength);
		for (int i = 0; i < model.boneLength; i++)
		{
			//dout.writeLine(model.getBone(i).toString());
		}
		
		/*
			これを
			Matrix.lookAtLH(
				bone.startPosition,
				bone.endPosition,
				bone.hPosition - bone.startPosition)
			とするとinverseがうまくいかないのでtranslationとlookAtを分割して処理する
		*/
		Bone bone = model.getBone(10);
		Bone a = nanami.model.mul3(bone, Matrix.identity);
		Bone b = nanami.model.mul3(bone,
			inverse(Matrix.translation(
				bone.startPosition.x, bone.startPosition.y, bone.startPosition.z))
			* Matrix.lookAtLH(
				Vector.create(0, 0, 0),
				bone.endPosition - bone.startPosition,
				bone.hPosition - bone.startPosition)
			);
		Bone c = nanami.model.mul3(b,
			inverse(Matrix.lookAtLH(
				Vector.create(0, 0, 0),
				bone.endPosition - bone.startPosition,
				bone.hPosition - bone.startPosition))
			* Matrix.translation(
				bone.startPosition.x, bone.startPosition.y, bone.startPosition.z)
			);
		
		Bone newBone = new Bone(0, 10, 0,  1, 11, 0,  0, 10, 1);
		Bone baseBone = new Bone(0, 0, 0,
			0, 0, distance(newBone.endPosition, newBone.startPosition),
			0, distance(newBone.hPosition, newBone.startPosition), 0);
		Bone d = nanami.model.mul3(baseBone,
			inverse(Matrix.lookAtLH(
				Vector.create(0, 0, 0),
				newBone.endPosition - newBone.startPosition,
				newBone.hPosition - newBone.startPosition))
			* Matrix.translation(
				newBone.startPosition.x, newBone.startPosition.y, newBone.startPosition.z)
			);
		
		Bone e = nanami.model.mul3(bone,
			inverse(Matrix.translation(
				bone.startPosition.x, bone.startPosition.y, bone.startPosition.z))
			* Matrix.lookAtLH(
				Vector.create(0, 0, 0),
				bone.endPosition - bone.startPosition,
				bone.hPosition - bone.startPosition)
			
			* Matrix.scaling(1.0,
				baseBone.hPosition.y / b.hPosition.y,
				baseBone.endPosition.z / b.endPosition.z)
			
			* inverse(Matrix.lookAtLH(
				Vector.create(0, 0, 0),
				newBone.endPosition - newBone.startPosition,
				newBone.hPosition - newBone.startPosition))
			* Matrix.translation(
				newBone.startPosition.x, newBone.startPosition.y, newBone.startPosition.z)
			);
		
		dout.writeLine(a.toString());
		dout.writeLine(b.toString());
		dout.writeLine(c.toString());
		dout.writeLine(d.toString());
		dout.writeLine(e.toString());
		
		float f = 0;
		while (true)
		{
			f += 1;
			if (f > 100) f = -100;
			//model.setBone(10, model.getBone(10));
			
			Bone a = model.getBone(12);
			Vector at = a.endPosition - a.startPosition;
			float atLength = length(at);
			at.x += f;
			at = normalize(at) * atLength;
			
			model.setBone(12, new Bone(a.startPosition, a.startPosition + at, a.hPosition));
			
			model.lookAt(15, vector(-200, f * 2, 0), vector(0, sin(f * 0.1), cos(f * 0.1)));
			wnd.update();
			sleep(15);
		}
	}
	catch (Exception e)
	{
		derr.writeLine(e.toString());
	}
	return 0;
}
